/*****************************************************************************
* checkbrute Checksum Bruteforcing Tool
* Copyright (C) 2020 Syping
*
* Redistribution and use in source and binary forms, with or without modification,
* are permitted provided that the following conditions are met:
*
* 1. Redistributions of source code must retain the above copyright notice,
* this list of conditions and the following disclaimer.
*
* 2. Redistributions in binary form must reproduce the above copyright notice,
* this list of conditions and the following disclaimer in the documentation
* and/or other materials provided with the distribution.
*
* This software is provided as-is, no warranties are given to you, we are not
* responsible for anything with use of the software, you are self responsible.
*****************************************************************************/

#ifndef CHECKSUM_QT_H
#define CHECKSUM_QT_H

#include <QCryptographicHash>
#include "checksum.h"

class checksum_qt : public checksum
{
    Q_OBJECT
public:
    explicit checksum_qt(QCryptographicHash::Algorithm algorithm, const QString &name);
    QByteArray generateChecksum(const QByteArray &data);
    const QString formatName();
    int checksumSize();

private:
    QCryptographicHash::Algorithm algorithm;
    QString name;
};

#endif // CHECKSUM_QT5_H
